#include <stdlib.h>
#include <stdio.h>
#include "sys.h"
#include "util.h"

#define  TIMEOUT_SLEEP_MODE     150
#define  TIMEOUT_CHOOSE_PAD      10
#define  TIMEOUT_PRESS_KEY       10
#define  TIMEOUT_RECEIVE_SIGNAL  60
#define  TIMEOUT_SHOW_MESSAGE     3

int buf[MAX_SIGNALS];                           //  ᨣ
int len;                                        //  ⮩  
int pad;                                        //  ⥪饩 ᪫
int key_for_bind;

int key = KEY_NOKEY;                            //  ⮩ 
int _signal;                                    // ਭ ᨣ

FILE* f;                                        //  ⮪

int full()
{
    return len == MAX_SIGNALS;
}

int x0()
{
    return key == KEY_RESET;
}

int x1()
{
    return key == KEY_RECORD;
}

int x2()
{
    return key == KEY_SET_PAD;
}

int x3()
{
    return full();
}

void z00()
{
    hash_load();
    pad = 0;
    say_ready();
}

void z01()
{
    hash_send(key);
}

void z02()
{
    message(MSG_WORK);
    set_timer(TIMEOUT_SLEEP_MODE);
}

void z03()
{
    message(MSG_CHOOSE_PAD);
    set_timer(TIMEOUT_CHOOSE_PAD);
}

void z04()
{
    pad = key;
}

void z05()
{
    message(MSG_PAD_NOT_CHOSEN);
}

void z06()
{
    message(MSG_PRESS_KEY);
    set_timer(TIMEOUT_PRESS_KEY);
}

void z07()
{
    message(MSG_RECORD_TIME_IS_UP);
}

void z08()
{
    key_for_bind = key;
    message(MSG_LISTEN);
    len = 0;
}

void z09()
{
    set_timer(TIMEOUT_RECEIVE_SIGNAL);
    if (full()) message(MSG_BUFFER_IS_FULL);
}

void z10()
{
    buf[len++] = _signal;
}

void z11()
{
    hash_bind();
    message(MSG_KEY_BINDED);
}

void z12()
{
    message(MSG_LISTEN_TIME_IS_UP);
}

void z13()
{
    message(MSG_BUFFER_OVERFLOW);
}

void z14()
{
    set_timer(TIMEOUT_SHOW_MESSAGE);
}

int Y;

void ARemote(int event)
{
    switch (Y)
    {
        case 0:
            if (event == 0)
            {
                z00();
                Y = 1;
            }
            break;
        case 1:
            if (event == 1)
                if      (x0())     z00();
                else if (x1())     Y = 4;
                else if (x2())     Y = 3;
                else               z01();
            else if (event == 2)   Y = 2;
            break;
        case 2:
            if (event == 1)        Y = 1;
            break;
        case 3:
            if (event == 1 && !x0() && !x1() && !x2())
            {
                z04();
                Y = 1;
            }
            else if (event == 2)
            {
                z05();
                Y = 6;
            }
            break;
        case 4:
            if (event == 1 && !x0() && !x1() && !x2())
            {
                z08();
                Y = 5;
            }
            else if (event == 2)
            {
                z07();
                Y = 6;
            }
            break;
        case 5:
            if (event == 2)
            {
                z12();
                Y = 6;
            }
            else if (event == 3)
                if (x3())
                {
                    z13();
                    Y = 6;
                }
                else z10();
            else if (event == 4 || event == 1 && x1())
            {
                z11();
                Y = 6;
            }
            break;
        case 6:
            if (event == 2)  Y = 1;
    }

    storeLog(event, Y);
    
    switch (Y)
    {
        case 1: z02(); break;
        case 3: z03(); break;
        case 4: z06(); break;
        case 5: z09(); break;
        case 6: z14();
    }
}

void start()
{
    Y = 0;        //  Y0:  Init  - 砫쭮 ﭨ
    ARemote(0);   //  e0:  Reset - 砫 ࠡ
}

void handleEvents()
{
    if (keypressed(&key))          ARemote(1);
    if (time_is_up())              ARemote(2);
    if (receive_signal(&_signal))  ARemote((_signal == STOP_SIGNAL) ? 4 : 3);
}

void done()
{
    fclose(f);
    printf("\n\n 襭.\n");
    exit(0);
}

void main()
{
    init_all();
    start();
    for (;;)
    {
        handleEvents();
        if (key == KEY_ESC) done();
    }
}