#include "..\src_sdk\ADuC812.h"
#include "..\src_sdk\lcd.h"
#include "..\src_sdk\max.h"

#include "sys.h"

//⠭ ᪮
#define S9600   0xFD
#define S4800   0xFA
#define S2400   0xF4
#define S1200   0xE8
#define REPEAT_DELAY 300

void InitSIO(char speed, bit sdouble)
{
    TH1      = speed; 
    TMOD    |= 0x20; // 1 㤥 ࠡ  ० autoreload

    if(sdouble)
        PCON|=0x80;//᫨ sdouble==1,  ᪮ 㤢
    else 
        PCON&=~0x80;

    TCON    |= 0x40; // ⠩ 1
    SCON     = 0x50; //ன ᫥⥫쭮 
    ES       = 0;    //饭 뢠  ਥ।稪
}

void init_all()
{
    InitLCD();	
    InitSIO(S9600, 0);
}

void wait_for_key()
{
    int key;
    while (keypressed(&key));
    while (!keypressed(&key));
    while (keypressed(&key));
}

void message(const char *s)
{
	LCD_Clear();
	LCD_Type(s);			
}

void say_ready()
{
    message(MSG_READY);
    wait_for_key();
}

void send(const int *signals)
{
    char c;
    int i;
    for (i = 0; c = (char)signals[i]; i++)
    {
        TI = 0;
        SBUF = c;
        while (!TI);
    }
}

int is_pressed(unsigned char row, unsigned char col)
{
    unsigned char addr = 0x080000, tmp;
    WriteMax(addr, ~(1 << col));
    tmp = ReadMax(addr) >> 4;
    return !(tmp & (1 << row));    
}

int keypressed(int *key)
{
    int i, j;
    for (i = 0; i < NUM_KEYS; i++)
    {
        if (is_pressed(i >> 2, i & 3))
        {
            *key = i;
            for (i = 0; i < REPEAT_DELAY; i++)
                for (j = 0; j < REPEAT_DELAY; j++);
            return 1;
        }
    }
    return 0;
}

int receive_signal(int *signal)
{
    if (RI) {
        RI = 0;			
        *signal = SBUF;				
        return 1;
    }
    return 0;
}

void storeLog(int event, int y)
{
}