#include "..\src_sdk\ADuC812.h"
#include "..\src_sdk\lcd.h"
#include "..\src_sdk\rtc.h"
#include "..\src_sdk\max.h"

#include "sys.h"
#include "util.h"

extern int buf[MAX_SIGNALS];                    //  ᨣ
extern int len;                                 //  ⮩  
extern int pad;                                 //  ⥪饩 ᪫
extern int key_for_bind;

int arr[NUM_PADS][NUM_KEYS][MAX_SIGNALS + 1];   // ন  

int timer_sec;                                  //  ᪮쪮 ⠭ ⠩
int timer_off = 1;                              // 몫祭  ⠩
TIME start_time;

void set_timer(int sec)
{
    timer_off = 0;
    timer_sec = sec;
    GetTime(&start_time);
}

int time_is_up()
{
    TIME now;
    long d;
    if (timer_off) return 0;
    GetTime(&now);
    d = (((long)now.hour - start_time.hour) * 60 + now.min - start_time.min)
        * 60 + now.sec - start_time.sec;
    if (d < 0) d += 86400L;
    timer_off = d >= timer_sec;
    return timer_off;
}

void hash_load()
{
    int i, j;
    for (i = 0; i < NUM_PADS; i++)
        for (j = 0; j < NUM_KEYS; j++)
            arr[i][j][0] = 0;
}

void hash_bind()
{
    int i;
    for (i = 0; i < len; i++)  arr[pad][key_for_bind][i] = buf[i];
    arr[pad][key_for_bind][i] = 0;
}

void hash_send(int key)
{
    send(arr[pad][key]);
}