/******************************************************************************
                ()  "", -, , 2002.
                http://lmt.cs.ifmo.ru, tel.: +7-812-233-3096,
                mailto: lmt@d1.ifmo.ru

         䠩  ᢮ ࠭塞 ਬ஬ ࠡ
     䥩ᮬ I2C 祡 ⥭ SDK-1.1  몥   (
    Keil C  KEIL ELEKTRONIK GmbH)   ।祭  樨
    ⢨ १ 䥩  slave-ன⢠.
          ணࠬ          ࣠   ⥫쭮
    ஢       ᮤঠ   訡.          
    ⢥⢥    ଠ樨        ।
    ᫥⢨ ᯮ짮  ணࠬ      ⠢
    ணࠬ ஥⮢.
         䠩  ࣠  ,     
    ࠭  ᪨ 楫      ⠢  ᪨
    ணࠬ த⮢.
    

:       i2c.c
:     1.0.1
:      LAN
ᠭ:    樮 ணࠬ ᯥ祭  ⥭
            SDK-1.1.   䥩 i2c  ० Master.

:
-------------------------------------------------------------------------------
N                        ᠭ   
-------------------------------------------------------------------------------
1 10.04.02  1.0.0   LAN     
2 23.04.02  1.0.1   LAN      㭪樨   ன⢠  
                        16-ࠧ來 ७  ࠭⢮
******************************************************************************/

#include "ADuC812.h"
#include "i2c.h"

/*----------------------------------------------------------------------------
                    㭪樨
 -----------------------------------------------------------------------------*/

/**----------------------------------------------------------------------------
                        Delay()
-------------------------------------------------------------------------------
প  ६ 浪 25 .

室:       
室:      
:  
----------------------------------------------------------------------------- */
static void Delay(void)
{
char ch=0;

    while(ch++ < 2);
}

/**----------------------------------------------------------------------------
                        SendByte()
-------------------------------------------------------------------------------
뫪  I2C  (8 )   ⢥ত (acknowledge).

室:       uchar ch - ,  㦭 ᫠.
室:      
:  0 - ⢥ত (acknowledge) 祭
            1 -  뫮 ⢥ত
----------------------------------------------------------------------------- */
static bit SendByte(unsigned char ch)//Returns ack (0 = acknowledged)
{
char cnt;
bit ack;

    MDE=1;//Output
    MCO=0;
    for(cnt=0; cnt<8; cnt++,ch<<=1)
    {
        MDO=(ch&0x80)?1:0;
        MCO=1;
        Delay();
        MCO=0;
    }
    MDE=0;//Input
    MCO=1;
    Delay();
    ack=MDI;
    MCO=0;
    return ack;
}

/**----------------------------------------------------------------------------
                        Start()
-------------------------------------------------------------------------------
⠭ ﭨ Start 䥩 i2c.

室:       
室:      
:  
----------------------------------------------------------------------------- */
static void Start(void)
{
    MDE=1;//Output
    MDO=1;
    MCO=1;
    Delay();
    MDO=0;
    Delay();
    MCO=0;
}

/**----------------------------------------------------------------------------
                        Stop()
-------------------------------------------------------------------------------
⠭ ﭨ Stop 䥩 i2c.

室:       
室:      
:  
----------------------------------------------------------------------------- */
static void Stop(void)
{
    MDE=1;//Output
    MCO=0;
    MDO=0;
    MCO=1;
    Delay();
    MDO=1;
    Delay();
    MDE=0;//Input (release line)
}


/**----------------------------------------------------------------------------
                        Begin()
-------------------------------------------------------------------------------
砫 ᨨ  䥩 i2c (Start + 뫪 i2c- slave-ன⢠).

室:       uchar addr - i2c- slave-ன⢠ 
室:      
:  0 - ன⢮ ⪫㫮 (祭 acknowledge)
            1 - ன⢮  ⪫㫮
----------------------------------------------------------------------------- */
static bit Begin(unsigned char addr)//Returns ack (0 = acknowledged)
{
    Start();
    return SendByte(addr);
}

/**----------------------------------------------------------------------------
                        Ack()
-------------------------------------------------------------------------------
뫪 ⢥ত (acknowledge) ன.

室:       
室:      
:  
----------------------------------------------------------------------------- */
static void Ack(void)//Sends ack
{
    MDE=1; //Output
    MCO=0;
    MDO=0;
    MCO=1;
    Delay();
    MCO=0;
}

/**----------------------------------------------------------------------------
                        Nack()
-------------------------------------------------------------------------------
뫪 "⢥ত" (not acknowledged) ன.

室:       
室:      
:  
----------------------------------------------------------------------------- */
static void Nack(void)//Sends NAck
{
    MDE=1;
    MCO=0;
    MDO=1;
    MCO=1;
    Delay();
    MCO=0;
}

/**----------------------------------------------------------------------------
                        GetAck()
-------------------------------------------------------------------------------
஢ઠ  ⮢ slave-ன⢠   (砫 + 祭 ⪫ +
襭 ᨨ)

室:       
室:      
:  
----------------------------------------------------------------------------- */
bit GetAck(unsigned char address) //Returns 1 if there was an ACK
{
    I2CM=1; //I2C Master mode
    if( Begin(address&0xFE) ){Stop();return 0;}
    Stop();

    return 1;
}


/**----------------------------------------------------------------------------
                        RecvByte()
-------------------------------------------------------------------------------
祭 8   設  i2c  ⢥ত  ⢥ত ਥ.

室:       
室:      
:  ਭ 8 .
----------------------------------------------------------------------------- */
unsigned char RecvByte(void)
{
char cnt;
unsigned char ch=0;

    MDE=0;//Input
    MCO=0;
    for(cnt=0; cnt<8; cnt++)
    {
        ch<<=1;
        MCO=1;
        Delay();
        ch|=MDI;
        MCO=0;
    }
    return ch;
}

/**----------------------------------------------------------------------------
                        ReceiveBlock()
-------------------------------------------------------------------------------
祭    i2c-ன⢠  8-ࠧ來 ७  
࠭⢮. ਭ  頥    xdata.

室:       uchar address - I2C- ன⢠;
            uchar addr -   ७ ᭮ ࠭⢥ ன⢠;
            uchar *block -    xdata, 㤠 㤥 饭 ਭ
                 ;
            uchar len -  ਭ .

室:      
:  0 - ᯥ譮;
            1 - ன⢮  ⪫.
----------------------------------------------------------------------------- */
bit ReceiveBlock(unsigned char address, unsigned char addr, unsigned char xdata * block,unsigned char len)
{ //addr - address in target
unsigned char l,ch;

    I2CM = 1; //I2C Master mode
    address &= 0xFE; //Write

    if( Begin(address) ) {Stop(); return 1;}//Error - No ACK
    if( SendByte(addr) ) {Stop(); return 1;}
    Delay();
    Delay();

    address |= 1;//Read
    if( Begin(address) ) {Stop();return 1;}
    Delay();

    if(len-1)
    {
        for(l=0; l<(len-1); l++)
        {
            ch = RecvByte();
            Ack();
            *block++ = ch;
        }
    }

    ch = RecvByte();
    Nack();
    *block = ch;
    Stop();
    return 0;
}

/**----------------------------------------------------------------------------
                        SendBlock()
-------------------------------------------------------------------------------
    ७  i2c-ன⢠  8-ࠧ來  
࠭⢮. 

室:       uchar address - I2C- ன⢠;
            uchar addr -   ७ ᭮ ࠭⢥ ன⢠,
                㤠 㤥 饭 ;
            uchar *block -    xdata,  ᯮ   
                뫪;
            uchar len -  뢠 .

室:      
:  0 - ᯥ譮;
            1 - ன⢮  ⪫.
----------------------------------------------------------------------------- */
bit TransmitBlock(unsigned char address, unsigned char addr, unsigned char xdata * block,unsigned char len)
{ //addr - address in target
unsigned char ch,l;

    I2CM = 1; //I2C Master mode
    address &= 0xFE; //Write
    if( Begin(address) ) {Stop(); return 1;}//Error - no Ack
    if( SendByte(addr) ) {Stop(); return 1;}

    for(l=0; l<len; l++,block++)
    {
        ch = *block;
        if(SendByte(ch)){ Stop(); return 1;}//Not to the end of the block
    }
    Stop();
    return 0;
}

/**----------------------------------------------------------------------------
                        ReceiveBlock16()
-------------------------------------------------------------------------------
祭    i2c-ன⢠  16-ࠧ來 ७  
࠭⢮. ਭ  頥    xdata.

室:       uchar address - I2C- ன⢠;
            ushort addr -   ७ ᭮ ࠭⢥ ன⢠;
            uchar *block -    xdata, 㤠 㤥 饭 ਭ
                 ;
            ushort len -  ਭ .

室:      
:  0 - ᯥ譮;
            1 - ன⢮  ⪫.
----------------------------------------------------------------------------- */
bit ReceiveBlock16(unsigned char address, unsigned short addr, unsigned char xdata * block,unsigned short len)
{ //addr - address in target
unsigned char ch;
unsigned short l;

    I2CM = 1; //I2C Master mode
    address &= 0xFE; //Write

    if( Begin(address) ){Stop(); return 1;}//Error - No ACK

    if( SendByte( (unsigned char)(addr>>8) ) ){Stop(); return 1;}
    if( SendByte( (unsigned char)addr ) ){Stop(); return 1;}

    Delay();
    Delay();

    address |= 1; //Read
    if( Begin(address) ) {Stop();return 1;}
    Delay();

    if(len-1)
    {
        for(l=0; l<(len-1); ++l)
        {
            ch = RecvByte();
            Ack();
            *block++ = ch;
        }
    }

    ch = RecvByte();
    Nack();
    *block = ch;
    Stop();
    return 0;
}

/**----------------------------------------------------------------------------
                        SendBlock16()
-------------------------------------------------------------------------------
    ७  i2c-ன⢠  16-ࠧ來  
࠭⢮. 

室:       uchar address - I2C- ன⢠;
            ushort addr -   ७ ᭮ ࠭⢥ ன⢠,
                㤠 㤥 饭 ;
            uchar *block -    xdata,  ᯮ   
                뫪;
            ushort len -  뢠 .

室:      
:  0 - ᯥ譮;
            1 - ன⢮  ⪫.
----------------------------------------------------------------------------- */
bit TransmitBlock16(unsigned char address, unsigned short addr, unsigned char xdata * block,unsigned short len)
{ //addr - address in target
unsigned char ch;
unsigned short l;

    I2CM = 1; //I2C Master mode
    address &= 0xFE; //Write

    if( Begin(address) ) {Stop(); return 1;}//Error - no Ack

    if( SendByte( (unsigned char)(addr >> 8) ) ) {Stop(); return 1;}
    if( SendByte( (unsigned char)addr ) ) {Stop(); return 1;}

    for(l = 0; l < len; l++, block++)
    {
        ch = *block;
        if( SendByte(ch) ) {Stop(); return 1;}//Not to the end of the block
    }

    Stop();
    return 0;
}


