/******************************************************************************
                ()  "", -, , 2002.
                http://lmt.cs.ifmo.ru, tel.: +7-812-233-3096,
                mailto: lmt@d1.ifmo.ru

         䠩   ᢮  ࠭塞  ਬ஬  
    몥    (  Keil  C    KEIL  ELEKTRONIK  GmbH)  
    ।祭    樨  ࠡ   ᠬ ॠ쭮 ६
    ⥭ SDK-1.1 PCF8583.
          ணࠬ          ࣠   ⥫쭮
    ஢       ᮤঠ   訡.          
    ⢥⢥    ଠ樨        ।
    ᫥⢨ ᯮ짮  ணࠬ      ⠢
    ணࠬ ஥⮢.
         䠩  ࣠  ,     
    ࠭  ᪨ 楫      ⠢  ᪨
    ணࠬ த⮢.
    

:       rtc.c
:     1.0.0
:      LAN
ᠭ:    樮 ணࠬ ᯥ祭  ⥭
            SDK-1.1.   ᠬ ॠ쭮 ६ PCF8583. 
             । 稥  ࠡ  䥩ᮬ I2C
            SDK-1.1 (i2c.c, i2c.h).

:
-------------------------------------------------------------------------------
N                        ᠭ   
-------------------------------------------------------------------------------
1 10.04.02  1.0.0   LAN     
******************************************************************************/
#include "i2c.h"
#include "rtc.h"


/*----------------------------------------------------------------------------
                    㭪樨
 -----------------------------------------------------------------------------*/

/**----------------------------------------------------------------------------
                        BCD2Bin()
-------------------------------------------------------------------------------
ॢ ᫠  ଠ BCD (binary-coded decimal)    ଠ

室:       uchar val - ᫮  BCD-ଠ
            
室:      
:   
----------------------------------------------------------------------------- */
#define BCD2Bin(val)    ( ((val)&0xF) + ( (((val)&0xF0)>>4) * 10 ) )

/**----------------------------------------------------------------------------
                        Bin2BCD()
-------------------------------------------------------------------------------
ॢ ᫠  ଠ BCD (binary-coded decimal)  筮 筮 ଠ

室:       uchar val - 筮 ᫮
            
室:      
:  BCD-
----------------------------------------------------------------------------- */
#define Bin2BCD(val)    ( ((val) % 10) + (((val) / 10)<<4) )


/**----------------------------------------------------------------------------
                        GetTime()
-------------------------------------------------------------------------------
祭 ⥪饣 ६

室:       TIME xdata * time - 㪠⥫     xdata, 㤠 
                㤥 饭 ⥪饥 ६.
            
室:      
:  0 - ᯥ譮;
            1 -   ⪫
----------------------------------------------------------------------------- */
bit GetTime(TIME xdata * time)
{
unsigned char h;

    if( !GetAck(RTC_ADDRESS) )
        return 1; //RTC failed to respond

    if( ReceiveBlock(RTC_ADDRESS, 1, (unsigned char xdata*)time, 4) )
        return 1; //Error reading

    time->hsec = BCD2Bin(time->hsec);
    time->sec  = BCD2Bin(time->sec);
    time->min  = BCD2Bin(time->min);
    h          = BCD2Bin(time->hour & 0x3F);

    if( time->hour & 0xC0 ) //12h format and pm time
    {
        if(time->hour < 12)
            time->hour = h + 12;
        else
            time->hour = 0;
    }
    else
        time->hour = h;

    return 0;
}


/**----------------------------------------------------------------------------
                        SetTime()
-------------------------------------------------------------------------------
⠭ ⥪饣 ६

室:       TIME xdata * time - 㪠⥫     xdata, 
                 ६.
            
室:      
:  0 - ᯥ譮;
            1 -   ⪫
----------------------------------------------------------------------------- */
bit SetTime(TIME xdata * time)
{
unsigned char h;
TIME t;

    if( !GetAck(RTC_ADDRESS) )
        return 1; //RTC failed to respond

    t.hsec = Bin2BCD(time->hsec);
    t.sec  = Bin2BCD(time->sec);
    t.min  = Bin2BCD(time->min);
    t.hour = Bin2BCD(time->hour & 0x3F);

    if( TransmitBlock(RTC_ADDRESS, 1, (unsigned char xdata*)&t, 4) )
        return 1; //Error reading

    return 0;
}

