#include "..\src_sdk\ADuC812.h"
#include "..\src_sdk\lcd.h"
#include "..\src_sdk\rtc.h"
#include "..\src_sdk\max.h"

#include "env.h"
//#include <stdio.h>
#include "common.h"

#define NUM_BASE 3
#define BITS_IN_SIGNAL 11
#define RECEIVE_OUT_OWN_PRIVATE_UNIQUE_DELAY 1000000

#define BUFFERLEN 16
//⠭ ᪮
#define S9600   0xFD
#define S4800   0xFA
#define S2400   0xF4
#define S1200   0xE8

void InitSIO(char speed, bit sdouble)
{
    TH1      = speed; 
    TMOD    |= 0x20; // 1 㤥 ࠡ  ० autoreload

    if(sdouble)
        PCON|=0x80;//᫨ sdouble==1,  ᪮ 㤢
    else 
        PCON&=~0x80;

    TCON    |= 0x40; // ⠩ 1
    SCON     = 0x50; //ன ᫥⥫쭮 
    ES       = 0;    //饭 뢠  ਥ।稪
}

void log(char* s) 
{

}

enum bool is_numeric_key(int key) {
	return key >= NUM_BASE && key <= NUM_BASE + 9;
}

int to_numeric(int key)
{
	return key - NUM_BASE;
}

void print(char* s)
{
	LCD_Clear();
	LCD_Type(s);			
}

void init_all(void) 
{
	InitLCD();	
	InitSIO(S9600, 0);
}

void send_char(char ch) 
{
    TI=0;    
    SBUF=ch;
    while(!TI);
}

void send_signal(int signal) 
{	
	send_char((char)signal);
}


enum bool receive_signal(int* signal) 
{
	if (RI)	{
		RI = 0;			
		*signal = SBUF;				
		return true; 
	} else {
		return false;
	}
}


enum bool elapsed = true;

TIME start_time;
int timer_sec;
void set_timer(int sec) 
{
	timer_sec = sec;
	elapsed = false;
	GetTime(&start_time);
}


enum bool time_elapsed() {
	TIME time;
	int d, ds, dm, dh;
	GetTime(&time);
	dh = time.hour - start_time.hour;
	dm = time.min - start_time.min;
	ds = time.sec - start_time.sec;
	d = ds + dm * 60 + dh * 60 * 60;
	if (d < 0) d += 24 * 60 * 60; 
	if (d >= timer_sec) {
		elapsed = true;		
	}
	return d >= timer_sec;
}

enum bool is_pressed(unsigned char row, unsigned char col)
{
	unsigned char addr = 0x080000;
    unsigned char tmp;
    WriteMax(addr, ~(1 << col));
    tmp = ReadMax(addr);

    tmp >>= 4;
    return !(tmp & (1 << row));    
}

enum bool is_key_pressed(int key)
{
	if (key == KEY_RECORD) return is_pressed(3,0);
	else if (key == KEY_CHANGE) return is_pressed(3,2);
    else switch (key - NUM_BASE) {
        case 0: return is_pressed(3,1);
        case 1: return is_pressed(0,0);
        case 2: return is_pressed(0,1);
        case 3: return is_pressed(0,2);
        case 4: return is_pressed(1,0);
        case 5: return is_pressed(1,1);
        case 6: return is_pressed(1,2);
        case 7: return is_pressed(2,0);
        case 8: return is_pressed(2,1);
        case 9: return is_pressed(2,2);
        case 10: return is_pressed(0,3);
        case 11: return is_pressed(1,3);
        case 12: return is_pressed(2,3);
        case 13: return is_pressed(3,3);
    }
    return false;
}

enum bool key_pressed(int* key) 
{
	int i;
	for (i = 0; i < NUM_KEYS; i++) {
		if (is_key_pressed(i)) {
			*key = i;
			return true;
		}
	}
	return false;				
}

